package atomfeed;

import javax.ws.rs.*;
import javax.ws.rs.core.*;
import javax.xml.bind.JAXBException;
import org.apache.abdera.model.*;

@Path( "atomfeedjaxb" )
public class JaxbAtomFeedService
{
   @GET @Produces( MediaType.APPLICATION_ATOM_XML )
   public static Feed getFeed( @Context UriInfo uri ) throws JAXBException
   {
      Feed feed = AbderaJaxRsProvider.getAbdera().getFactory().newFeed();
      JaxbDatenDAO.fillFeedData( feed, uri.getAbsolutePath().toString() );
      for( Long id : JaxbDatenDAO.getListOfIDs() ) {
         Entry entry = feed.addEntry();
         JaxbDatenDAO.fillEntryData( entry, id, uri.getAbsolutePath().toString() );
      }
      return feed;
   }

   @Path( "entry/{id}" )
   @GET @Produces( MediaType.APPLICATION_ATOM_XML )
   public static Entry getEntry( @PathParam("id") Long id, @Context UriInfo uri ) throws JAXBException
   {
      Entry entry = AbderaJaxRsProvider.getAbdera().getFactory().newEntry();
      JaxbDatenDAO.fillEntryData( entry, id, uri.getAbsolutePath().toString() );
      return entry;
   }

   @Path( "entry" )
   @PUT @Consumes( MediaType.APPLICATION_ATOM_XML )
   public String putEntry( Entry entry ) throws JAXBException
   {
      return JaxbDatenDAO.storeContent( entry );
   }
}
