package atomfeed;

import javax.ws.rs.*;
import javax.ws.rs.core.*;
import org.apache.abdera.model.*;

@Path( "atomfeed" )
public class SimpleAtomFeedService
{
   @GET @Produces( MediaType.APPLICATION_ATOM_XML )
   public static Feed getFeed( @Context UriInfo uri )
   {
      Feed feed = AbderaJaxRsProvider.getAbdera().getFactory().newFeed();
      SimpleDatenDAO.fillFeedData( feed, uri.getAbsolutePath().toString() );
      for( Long id : SimpleDatenDAO.getListOfIDs() ) {
         Entry entry = feed.addEntry();
         SimpleDatenDAO.fillEntryData( entry, id, uri.getAbsolutePath().toString() );
      }
      return feed;
   }

   @Path( "entry/{id}" )
   @GET @Produces( MediaType.APPLICATION_ATOM_XML )
   public static Entry getEntry( @PathParam("id") Long id, @Context UriInfo uri )
   {
      Entry entry = AbderaJaxRsProvider.getAbdera().getFactory().newEntry();
      SimpleDatenDAO.fillEntryData( entry, id, uri.getAbsolutePath().toString() );
      return entry;
   }
}
