package atomfeed;

import java.util.*;
import org.apache.abdera.model.*;

/**
 * Simple Simulation von Daten-Lieferanten.
 * In der Realitaet koennten die Daten aus einer Datenbank kommen.
 */
public class SimpleDatenDAO
{
   public static void fillFeedData( Feed feed, String uri )
   {
      feed.setId(       uri );
      feed.setUpdated(  new Date() );
      feed.setTitle(    "Mein Feed-Titel" );
      feed.setSubtitle( "Mein Feed-Untertitel" );
      feed.addAuthor(   "ich" );
      feed.addLink(     "http://www.torsten-horn.de/techdocs/jee-rest.htm" );
      feed.addLink(     uri, "self" );
   }

   public static void fillEntryData( Entry entry, Long idNum, String uri )
   {
      long id = ( idNum != null ) ? idNum.longValue() : 4711;
      entry.setId(      uri + "/entry/" + id );
      entry.setUpdated( new Date( new Date().getTime() - (long)(100000000 * Math.exp( -id / 100. )) ) );
      entry.setTitle(   "Titel zum Entry mit der ID " + id );
      entry.setContent( "Hier ist der Inhalt des Entrys mit der ID " + id );
      entry.addAuthor(  "ich" );
   }

   public static List<Long> getListOfIDs()
   {
      return Arrays.asList( new Long[] { Long.valueOf( 4711 ), Long.valueOf( 42 ), Long.valueOf( 7 ) } );
   }
}
