package atomfeed;

import java.net.URL;
import com.sun.jersey.api.container.grizzly2.GrizzlyServerFactory;
import org.apache.abdera.Abdera;
import org.apache.abdera.model.*;
import org.apache.abdera.parser.Parser;
import org.glassfish.grizzly.http.server.HttpServer;
import org.junit.*;

public class SimpleAtomFeedServiceTest
{
   @Test
   public void testSimpleAtomFeedService() throws Exception
   {
      String urlSrvr  = "http://localhost:4434";
      String urlFeed  = urlSrvr + "/atomfeed";
      String urlEntry = urlSrvr + "/atomfeed/entry/13";
      Parser parser   = new Abdera().getParser();

      // Testserver:
      HttpServer srv = GrizzlyServerFactory.createHttpServer( urlSrvr );

      try {

         // Teste Entry:
         URL             urlE = new URL( urlEntry );
         Document<Entry> docE = parser.parse( urlE.openStream(), urlE.toString() );
         Entry           entry1 = docE.getRoot();
         Assert.assertEquals( "Titel zum Entry mit der ID 13", entry1.getTitle() );
         Assert.assertEquals( "Hier ist der Inhalt des Entrys mit der ID 13", entry1.getContent() );
         Assert.assertEquals( "ich", entry1.getAuthor().getName() );

         // Teste Feed:
         URL            urlF = new URL( urlFeed );
         Document<Feed> docF = parser.parse( urlF.openStream(), urlF.toString() );
         Feed           feed = docF.getRoot();
         Assert.assertEquals( "Mein Feed-Titel", feed.getTitle() );
         Assert.assertEquals( "ich", feed.getAuthor().getName() );
         Assert.assertEquals( 3, feed.getEntries().size() );
         for( Entry entry : feed.getEntries() ) {
            Assert.assertTrue( entry.getTitle().startsWith( "Titel zum Entry mit der ID " ) );
            Assert.assertTrue( entry.getContent().startsWith( "Hier ist der Inhalt des Entrys " ) );
         }

      } finally {
         // Testserver beenden:
         srv.stop();
      }
   }
}
