package contractfirstservice;

import javax.xml.bind.JAXBElement;
import com.sun.jersey.api.client.WebResource;
import org.junit.*;
import contractfirstgenerated.*;

public class ContractfirstServiceTest
{
   @Test
   public void testContractfirstService() throws Exception
   {
      final String xmlUtf8 = "text/xml; charset=utf-8";

      try( RestServerTestUtil restServerTestUtil = new RestServerTestUtil( "/contractfirst" ) )
      {
         WebResource wrs = restServerTestUtil.getWebResource();

         // Mit JAXB und mit bequemen Java-Objekten:
         InputTO inpTO = new InputTO();
         inpTO.setI( 42 );
         inpTO.setS( "abc xyz" );
         JAXBElement<InputTO> inpJaxb = (new ObjectFactory()).createInputTO( inpTO );
         ResultTO resTO = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post( ResultTO.class, inpJaxb );
         Assert.assertEquals(  84,             resTO.getI() );
         Assert.assertEquals( "abc xyz - ret", resTO.getS() );

         // Ohne JAXB und mit XML-Strings (Namespace beachten):
         String resXml = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post(
                              String.class, "<inputTO xmlns='mein.ns'><i>42</i><s>abc xyz</s></inputTO>" );
         Assert.assertEquals( "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>" +
                              "<resultTO xmlns=\"mein.ns\"><i>84</i><s>abc xyz - ret</s></resultTO>", resXml );
      }
   }
}
