package integrationstest;

import javax.xml.bind.JAXBElement;
import org.junit.*;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.filter.HTTPBasicAuthFilter;
import contractfirstgenerated.*;

public class JaxRsAuthenticationIntegrTest
{
   @Test
   public void testJaxRsAuthentication() throws Exception
   {
      // Testclient:
      final String xmlUtf8 = "text/xml; charset=utf-8";
      String url = "http://localhost:8080/JaxRsAuthentication/rest/contractfirst";
      String usr = "MeinName";
      String pwd = "MeinPasswort";
      Client clt = Client.create();
      clt.addFilter( new HTTPBasicAuthFilter( usr, pwd ) );
      WebResource wrs = clt.resource( url );

      // Mit JAXB und mit bequemen Java-Objekten:
      InputTO inpTO = new InputTO();
      inpTO.setI( 42 );
      inpTO.setS( "abc xyz" );
      JAXBElement<InputTO> inpJaxb = (new ObjectFactory()).createInputTO( inpTO );
      ResultTO resTO = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post( ResultTO.class, inpJaxb );
      Assert.assertEquals(  84,             resTO.getI() );
      Assert.assertEquals( "abc xyz - ret", resTO.getS() );

      // Ohne JAXB und mit XML-Strings (Namespace beachten):
      String resXml = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post(
                           String.class, "<inputTO xmlns='mein.ns'><i>42</i><s>abc xyz</s></inputTO>" );
      Assert.assertEquals( "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>" +
                           "<resultTO xmlns=\"mein.ns\"><i>84</i><s>abc xyz - ret</s></resultTO>", resXml );

      // Eventuell verzoegerte Beendigung (siehe Text):
      // Thread.sleep( 20000 );
   }
}
