package contractfirstservice;

import java.io.IOException;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.container.grizzly2.GrizzlyServerFactory;
import org.glassfish.grizzly.http.server.HttpServer;

public class RestServerTestUtil implements AutoCloseable
{
   private String urlSrvr = "http://localhost:4434";
   private String urlRest = null;
   private HttpServer srv = null;

   // Fuer normale Modultests:
   public RestServerTestUtil( String restPath ) throws IOException
   {
      urlRest = urlSrvr + restPath;
      // Grizzly-Testserver starten:
      srv = GrizzlyServerFactory.createHttpServer( urlSrvr );
   }

   // Falls ein HTTP-Monitor oder TCP/IP-Monitor zwischengeschaltet werden soll:
   public RestServerTestUtil( String urlSrvr, String urlRest ) throws IOException
   {
      this.urlSrvr = urlSrvr;
      this.urlRest = urlRest;
      // Grizzly-Testserver starten:
      srv = GrizzlyServerFactory.createHttpServer( urlSrvr );
   }

   @Override
   public void close()
   {
      if( srv != null ) {
         // Eventuell verzoegerte Beendigung:
         // Thread.sleep( 20000 );
         // Grizzly-Testserver beenden:
         srv.stop();
         srv = null;
      }
   }

   public WebResource getWebResource()
   {
      return Client.create().resource( urlRest );
   }
}
