package de.meinefirma.meinprojekt.buecher;

import javax.jws.WebService;
import de.meinefirma.meinprojekt.dao.*;

/** Dienstimplementierung */
@WebService( endpointInterface="de.meinefirma.meinprojekt.buecher.BuecherSoapServiceIntf" )
public class BuecherSoapServiceImpl implements BuecherSoapServiceIntf
{
   private BuchDoDAO dao = BuchDoDAO.getInstance();

   @Override public BuecherTO createBuch( BuchDO bu ) throws Exception
   {
      bu = dao.createBuch( bu );
      return BuecherUtil.erzeugeBuecherTO( "Buch hinzugefuegt", bu );
   }

   @Override public BuecherTO getBuchById( Long id )
   {
      BuchDO bu = dao.getBuchById( id );
      return BuecherUtil.erzeugeBuecherTO( "Buch mit ID " + id, bu );
   }

   @Override public BuecherTO findeBuecher( BuchDO bu )
   {
      return BuecherUtil.findeBuecher( bu.getId(), bu.getIsbn(), bu.getTitel() );
   }
}
