package minirestwebservice;

import javax.ws.rs.core.MediaType;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.container.grizzly2.GrizzlyServerFactory;
import org.glassfish.grizzly.http.server.HttpServer;
import org.junit.*;

public class HalloWeltServiceTest
{
   @Test
   public void testRESTfulWebService() throws Exception
   {
      String urlSrvr = "http://localhost:4434";
      String urlRest = urlSrvr + "/helloworld?name=MeinName";

      // Testserver:
      HttpServer srv = GrizzlyServerFactory.createHttpServer( urlSrvr );

      try {
         // Testclient:
         WebResource wrs = Client.create().resource( urlRest );
         String      txt = wrs.accept( MediaType.TEXT_PLAIN ).get( String.class );
         String      htm = wrs.accept( MediaType.TEXT_HTML  ).get( String.class );

         // Pruefungen:
         Assert.assertEquals( "Hallo MeinName", txt );
         Assert.assertEquals( "<html><title>HelloWorld</title><body><h2>Html: Hallo MeinName</h2></body></html>", htm );

      } finally {
         // Testserver beenden:
         srv.stop();
      }
   }
}
