package xmljaxb;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.container.grizzly2.GrizzlyServerFactory;
import org.glassfish.grizzly.http.server.HttpServer;
import org.junit.*;

public class XmlJaxbServiceTest
{
   @Test
   public void testXmlJaxbService() throws Exception
   {
      String urlSrvr = "http://localhost:4434";
      String urlRest = urlSrvr + "/xmljaxb";
      String xmlUtf8 = "text/xml; charset=utf-8";

      // Testserver:
      HttpServer srv = GrizzlyServerFactory.createHttpServer( urlSrvr );

      try {
         // Testclient:
         WebResource wrs = Client.create().resource( urlRest );

         // Mit JAXB und mit bequemen Java-Objekten:
         InputTO inpTO = new InputTO();
         inpTO.i = 42;
         inpTO.s = "abc xyz";
         ResultTO resTO = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post( ResultTO.class, inpTO );
         Assert.assertEquals(  84,             resTO.i );
         Assert.assertEquals( "abc xyz - ret", resTO.s );

         // Ohne JAXB und mit XML-Strings:
         String resXml = wrs.type( xmlUtf8 ).accept( xmlUtf8 ).post(
                              String.class, "<inputTO><i>42</i><s>abc xyz</s></inputTO>" );
         Assert.assertEquals( "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>" +
                              "<resultTO><i>84</i><s>abc xyz - ret</s></resultTO>", resXml );

      } finally {
         // Eventuell verzoegerte Beendigung:
         // Thread.sleep( 20000 );
         // Testserver beenden:
         srv.stop();
      }
   }
}
